> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/guides/deploy/server-configuration/database-servers/sqlserver.md).

# SQLServer

## Permissions and database metadata

SQL Server has different roles which define which permissions a user has.

Users with role `db_owner` all permissions needed, this is the advised role for connection Servoy to a SQL Server database.

If you use a user with a more restricted role, like `db_datareader`/`db_datawriter`, by default it does not have access to metadata stored in the information schema.

When Servoy will read the database metadata, it may, for example, not see that a column has a default value which may result in errors when inserting data.

So, when using a role with limited rights, you also need to check access to the information schema.

An example of assigning the roles is:

```
1> use mydb
2> go
Changed database context to 'MYDBDB'.
1> grant view definition to SERVOYUSER
2> go
```

Note that in some situations Servoy will try to create temporary tables to run certain queries.

If it cannot do that because of missing permissions, the query will fail and the user will get an error.

See also

* Database Level Roles <https://docs.microsoft.com/en-us/sql/relational-databases/security/authentication-access/database-level-roles>
* granting view permissions <https://www.mssqltips.com/sqlservertip/1593/granting-view-definition-permission-to-a-user-or-role-in-sql-server>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.servoy.com/guides/deploy/server-configuration/database-servers/sqlserver.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
